FUNCTION_BLOCK W_to_B_ON
  VAR_INPUT
    In0 : WORD;
  END_VAR
  VAR
    Val_comp : WORD := 32753;
    Val0 : BOOL;
    Out0 : BOOL := false;
    Out1 : BOOL := true;
  END_VAR
  VAR_OUTPUT
    Out : BOOL;
  END_VAR

  IF In0 > Val_comp THEN
    Val0 := Out1;
  ELSE
    Val0 := Out0;
  END_IF;

  Out := Val0;
END_FUNCTION_BLOCK

FUNCTION_BLOCK B_to_W_ON
  VAR_INPUT
    In0 : BOOL;
  END_VAR
  VAR
    Val0 : WORD;
    Out0 : WORD := 0;
    Out1 : WORD := 65535;
  END_VAR
  VAR_OUTPUT
    Out : WORD;
  END_VAR

  IF In0 THEN
    Val0 := Out1;
  ELSE
    Val0 := Out0;
  END_IF;

  Out := Val0;
END_FUNCTION_BLOCK

PROGRAM UNO_Conveyor
  VAR
    out_3 AT %QW100 : WORD := 0;
    out_5 AT %QW101 : WORD := 0;
    out_4 AT %QX100.0 : BOOL := true;
    out_8 AT %QX100.1 : BOOL := true;
    inp_a4 AT %IW104 : WORD := 0;
    inp_a5 AT %IW105 : WORD := 0;
  END_VAR
  VAR
    W_to_B_ON5 : W_to_B_ON;
    TOF0 : TOF;
    F_TRIG0 : F_TRIG;
    B_to_W_ON0 : B_to_W_ON;
    TOF1 : TOF;
    F_TRIG1 : F_TRIG;
    B_to_W_ON1 : B_to_W_ON;
    W_to_B_ON6 : W_to_B_ON;
    OR111_OUT : WORD;
    NOT4_OUT : WORD;
    WORD_TO_BOOL105_OUT : BOOL;
  END_VAR

  out_4 := TRUE;
  OR111_OUT := OR(out_3, out_5);
  NOT4_OUT := NOT(OR111_OUT);
  WORD_TO_BOOL105_OUT := WORD_TO_BOOL(NOT4_OUT);
  out_8 := WORD_TO_BOOL105_OUT;
  W_to_B_ON6(In0 := inp_a4);
  F_TRIG1(CLK := W_to_B_ON6.Out);
  TOF1(IN := F_TRIG1.Q, PT := T#2s);
  B_to_W_ON1(In0 := TOF1.Q);
  out_5 := B_to_W_ON1.Out;
  W_to_B_ON5(In0 := inp_a5);
  F_TRIG0(CLK := W_to_B_ON5.Out);
  TOF0(IN := F_TRIG0.Q, PT := T#2s);
  B_to_W_ON0(In0 := TOF0.Q);
  out_3 := B_to_W_ON0.Out;
END_PROGRAM

FUNCTION_BLOCK W_to_B_OFF
  VAR_INPUT
    In0 : WORD;
  END_VAR
  VAR
    Val_comp : WORD := 32753;
    Val0 : BOOL;
    Out0 : BOOL := false;
    Out1 : BOOL := true;
  END_VAR
  VAR_OUTPUT
    Out : BOOL;
  END_VAR

  IF In0 < Val_comp THEN
    Val0 := Out1;
  ELSE
    Val0 := Out0;
  END_IF;

  Out := Val0;
END_FUNCTION_BLOCK


CONFIGURATION Config0

  RESOURCE Res0 ON PLC
    TASK task0(INTERVAL := T#20ms,PRIORITY := 0);
    PROGRAM instance0 WITH task0 : UNO_Conveyor;
  END_RESOURCE
END_CONFIGURATION
